﻿var cTID = function(s) {
    return app.charIDToTypeID(s);
};
var sTID = function(s) {
    return app.stringIDToTypeID(s);
};

function isOpen() {
    if (documents.length) {
        return true;
    } else {
        alert("没有打开的文件。", "BBTools Shadow", false);
        return false;
    }
}

function isRGB() {
    if (app.activeDocument.mode == DocumentMode.RGB) {
        return true;
    } else {
        alert("将文档转换为RGB模式。", "BBTools Shadow", false);
        return false;
    }
}

function isNotEmpty() {
    if (app.activeDocument.activeLayer.bounds[0].value !== app.activeDocument.activeLayer.bounds[2].value) {
        return true;
    } else {
        alert("选择图层为空。", "BBTools Shadow", false);
        return false;
    }
}

function noBackgroundLayer() {
    if (!app.activeDocument.activeLayer.isBackgroundLayer) {
        return true;
    } else {
        alert("背景图层不能创建投影。", "BBTools Shadow", false);
        return false;
    }
}

function getSelectedLayersID() {
    var selectedLayersIdx = getSelectedLayersIdx();
    var selectedLayersID = new Array();
    for (var i = 0; i < selectedLayersIdx.length; i += 1) {
        selectedLayersID.push(changeLayerIdxToLayerID(selectedLayersIdx[i]));
    }
    return selectedLayersID;
}

function getSelectedLayersIdx() {
    var selectedLayers = new Array();
    var ref = new ActionReference();
    ref.putEnumerated(charIDToTypeID("Dcmn"), charIDToTypeID("Ordn"), charIDToTypeID("Trgt"));
    var desc = executeActionGet(ref);
    if (desc.hasKey(stringIDToTypeID("targetLayers"))) {
        desc = desc.getList(stringIDToTypeID("targetLayers"));
        var c = desc.count;
        var selectedLayersIdx = new Array();
        for (var i = 0; i < c; i += 1) {
            try {
                activeDocument.backgroundLayer;
                selectedLayersIdx.push(desc.getReference(i).getIndex());
            } catch (e) {
                selectedLayersIdx.push(desc.getReference(i).getIndex() + 1);
            }
        }
    } else {
        var ref = new ActionReference();
        ref.putProperty(charIDToTypeID("Prpr"), charIDToTypeID("ItmI"));
        ref.putEnumerated(charIDToTypeID("Lyr "), charIDToTypeID("Ordn"), charIDToTypeID("Trgt"));
        try {
            activeDocument.backgroundLayer;
            selectedLayersIdx.push(executeActionGet(ref).getInteger(charIDToTypeID("ItmI")) - 1);
        } catch (e) {
            selectedLayersIdx.push(executeActionGet(ref).getInteger(charIDToTypeID("ItmI")));
        }
    }
    return selectedLayersIdx;
}

function changeLayerIdxToLayerID(idx) {
    ref = new ActionReference();
    ref.putProperty(charIDToTypeID("Prpr"), charIDToTypeID("LyrI"));
    ref.putIndex(charIDToTypeID("Lyr "), idx);
    return executeActionGet(ref).getInteger(stringIDToTypeID("layerID"));
}

function onlyOneLayerSelected() {
    var layers = getSelectedLayersID();
    if (layers.length === 1) {
        return true;
    } else {
        alert("请选择单个图层！", "BBTools Shadow", false);
    }
}

function isValidLayer() {
    var theLayer = app.activeDocument.activeLayer;
    if (theLayer.kind == "LayerKind.SMARTOBJECT" || theLayer.kind == "LayerKind.NORMAL" || theLayer.kind == "LayerKind.TEXT") {
        return true;
    } else {
        alert("无效的图层（请尝试栅格化图层）。", "BBTools Shadow", false);
        return false;
    }
}

function showError(err) {
    if (confirm("无法识别该错误\n想要了解更多信息么?", true, "Unknown Error")) {
        alert(err + ": 问题位于该行 " + err.line, "Script Error", true);
    }
}

function motionBlur(theValue) {
    var desc1 = new ActionDescriptor();
    desc1.putInteger(cTID("Angl"), 0);
    desc1.putUnitDouble(cTID("Dstn"), cTID("#Pxl"), theValue);
    executeAction(sTID("motionBlur"), desc1, DialogModes.NO);
}

function pathName() {
    var doc = app.activeDocument;
    pathLength = doc.pathItems.length;
    for (var i = 0; i < pathLength; i += 1) {
        if (doc.pathItems[i].name == "Sun" || doc.pathItems[i].name == "Work Path") {
            sunPointName = doc.pathItems[i];
            return sunPointName;
        }
    }
}

function calcSunAngle() {
    var doc = app.activeDocument;
    var objPointX = 0;
    var objPointY = 0;
    var sunPointX = 0;
    var sunPointY = 0;
    var sunAngle = 0;
    var sunAXY = [];
    objPointX = Math.floor(doc.activeLayer.bounds[0].value + ((doc.activeLayer.bounds[2].value - doc.activeLayer.bounds[0].value) / 2));
    objPointY = Math.floor(doc.activeLayer.bounds[3].value);
    if (doc.pathItems.length > 0) {
        sunPoint = pathName();
        if (sunPoint.subPathItems.length > 1 || sunPoint.subPathItems[0].pathPoints.length > 1) {
            alert("只能定义一个太阳位置！", "BBTools Shadow", false);
            return;
        } else {
            sunPointX = sunPoint.subPathItems[0].pathPoints[0].anchor[0];
            sunPointY = sunPoint.subPathItems[0].pathPoints[0].anchor[1];
            sunAngle = Math.floor((Math.atan2(sunPointY - objPointY, sunPointX - objPointX) * 180) / Math.PI);
            if (sunAngle > -180 && sunAngle < 90) {
                sunAngle = sunAngle + 270;
            } else {
                sunAngle = sunAngle - 90;
            }
            sunPoint.remove();
            sunAXY.push(sunAngle, sunPointX, sunPointY);
            return sunAXY;
        }
    } else {
        alert("请定义一个太阳位置！", "BBTools Shadow", false);
        return sunAXY;
    }
}

function returnSun(point) {
    var doc = app.activeDocument;
    var startPoint = new PathPointInfo();
    startPoint.anchor = point;
    startPoint.leftDirection = point;
    startPoint.rightDirection = point;
    startPoint.kind = PointKind.CORNERPOINT;
    var spi = new SubPathInfo();
    spi.closed = false;
    spi.operation = ShapeOperation.SHAPEXOR;
    spi.entireSubPath = [startPoint];
    var line = doc.pathItems.add("Sun", [spi]);
}

function hasLayerMask() {
    try {
        var ref = new ActionReference();
        var keyUserMaskEnabled = app.charIDToTypeID("UsrM");
        ref.putProperty(app.charIDToTypeID("Prpr"), keyUserMaskEnabled);
        ref.putEnumerated(app.charIDToTypeID("Lyr "), app.charIDToTypeID("Ordn"), app.charIDToTypeID("Trgt"));
        var desc = executeActionGet(ref);
        if (desc.hasKey(keyUserMaskEnabled)) {
            return true;
        }
    } catch (e) {
        return false;
    }
}

function applyLayerMask() {
    var theLayer = app.activeDocument.activeLayer;

    function step1(enabled, withDialog) {
        if (enabled != undefined && !enabled) {
            return;
        }
        var dialogMode = withDialog ? DialogModes.ALL : DialogModes.NO;
        var desc1 = new ActionDescriptor();
        var ref1 = new ActionReference();
        ref1.putEnumerated(cTID("Chnl"), cTID("Chnl"), cTID("Msk "));
        desc1.putReference(cTID("null"), ref1);
        desc1.putBoolean(cTID("MkVs"), false);
        executeAction(cTID("slct"), desc1, dialogMode);
    }

    function step2(enabled, withDialog) {
        if (enabled != undefined && !enabled) {
            return;
        }
        var dialogMode = withDialog ? DialogModes.ALL : DialogModes.NO;
        var desc1 = new ActionDescriptor();
        var ref1 = new ActionReference();
        ref1.putEnumerated(cTID("Chnl"), cTID("Ordn"), cTID("Trgt"));
        desc1.putReference(cTID("null"), ref1);
        desc1.putBoolean(cTID("Aply"), true);
        executeAction(cTID("Dlt "), desc1, dialogMode);
    }
    theLayer.rasterize(RasterizeType.ENTIRELAYER);
    step1();
    step2();
}

function setShadowAngle(layerAngle, layerScale) {
    var desc1 = new ActionDescriptor();
    var ref1 = new ActionReference();
    app.activeDocument.activeLayer.applyGaussianBlur(1);
    ref1.putEnumerated(cTID("Lyr "), cTID("Ordn"), cTID("Trgt"));
    desc1.putReference(cTID("null"), ref1);
    desc1.putEnumerated(cTID("FTcs"), cTID("QCSt"), sTID("QCSSide2"));
    var desc2 = new ActionDescriptor();
    desc2.putUnitDouble(cTID("Hrzn"), cTID("#Pxl"), -12.7460808644879);
    desc2.putUnitDouble(cTID("Vrtc"), cTID("#Pxl"), 0);
    desc1.putObject(cTID("Ofst"), cTID("Ofst"), desc2);
    var desc3 = new ActionDescriptor();
    if (layerAngle > 0 && layerAngle < 90) {
        desc1.putUnitDouble(cTID("Hght"), cTID("#Prc"), layerScale);
        desc3.putUnitDouble(cTID("Hrzn"), cTID("#Ang"), -layerAngle);
        desc3.putUnitDouble(cTID("Vrtc"), cTID("#Ang"), 0);
    } else if (layerAngle > 90 && layerAngle < 180) {
        desc1.putUnitDouble(cTID("Hght"), cTID("#Prc"), -layerScale);
        desc3.putUnitDouble(cTID("Hrzn"), cTID("#Ang"), -layerAngle);
        desc3.putUnitDouble(cTID("Vrtc"), cTID("#Ang"), 0);
    } else if (layerAngle > 180 && layerAngle < 270) {
        desc1.putUnitDouble(cTID("Hght"), cTID("#Prc"), -layerScale);
        desc3.putUnitDouble(cTID("Hrzn"), cTID("#Ang"), -layerAngle);
        desc3.putUnitDouble(cTID("Vrtc"), cTID("#Ang"), 0);
    } else if (layerAngle > 270 && layerAngle < 360) {
        desc1.putUnitDouble(cTID("Hght"), cTID("#Prc"), layerScale);
        desc3.putUnitDouble(cTID("Hrzn"), cTID("#Ang"), -layerAngle);
        desc3.putUnitDouble(cTID("Vrtc"), cTID("#Ang"), 0);
    } else if (layerAngle == 90) {
        desc1.putUnitDouble(cTID("Hght"), cTID("#Prc"), -layerScale);
        desc3.putUnitDouble(cTID("Hrzn"), cTID("#Ang"), -(layerAngle + 1));
        desc3.putUnitDouble(cTID("Vrtc"), cTID("#Ang"), 0);
    } else if (layerAngle == 180) {
        desc1.putUnitDouble(cTID("Hght"), cTID("#Prc"), -layerScale);
        desc3.putUnitDouble(cTID("Hrzn"), cTID("#Ang"), -(layerAngle + 1));
        desc3.putUnitDouble(cTID("Vrtc"), cTID("#Ang"), 0);
    } else {
        if (layerAngle == 270) {
            desc1.putUnitDouble(cTID("Hght"), cTID("#Prc"), layerScale);
            desc3.putUnitDouble(cTID("Hrzn"), cTID("#Ang"), -(layerAngle + 1));
            desc3.putUnitDouble(cTID("Vrtc"), cTID("#Ang"), 0);
        }
    }
    desc1.putObject(cTID("Skew"), cTID("Pnt "), desc3);
    desc1.putEnumerated(cTID("Intr"), cTID("Intp"), sTID("bicubicSmoother"));
    executeAction(cTID("Trnf"), desc1, DialogModes.NO);
}

function setShadowBlur(layerAngle, layerBlur) {
    var doc = app.activeDocument;
    var desc1 = new ActionDescriptor();
    var ref1 = new ActionReference();
    ref1.putEnumerated(cTID("Lyr "), cTID("Ordn"), cTID("Trgt"));
    desc1.putReference(cTID("null"), ref1);
    desc1.putBoolean(sTID("blurbType"), true);
    desc1.putInteger(cTID("VrsM"), 1);
    desc1.putInteger(cTID("VrsN"), 0);
    var desc2 = new ActionDescriptor();
    desc2.putInteger(cTID("Top "), 0);
    desc2.putInteger(cTID("Left"), 0);
    desc2.putInteger(cTID("Btom"), doc.height);
    desc2.putInteger(cTID("Rght"), doc.width);
    desc1.putObject(sTID("referenceRect"), cTID("Rctn"), desc2);
    desc1.putInteger(sTID("blurbOpenPanel"), 3);
    desc1.putBoolean(sTID("blurbLensTiltEffectApplied"), true);
    desc1.putBoolean(sTID("blurbSaveMaskChannel"), false);
    desc1.putBoolean(sTID("blurbHighQuality"), false);
    var list1 = new ActionList();
    var desc3 = new ActionDescriptor();
    if (layerAngle > 0 && layerAngle < 90) {
        desc3.putInteger(sTID("blurbWidgetType"), 3);
        desc3.putDouble(sTID("blurbWidgetLocationX"), doc.activeLayer.bounds[0].value + ((doc.activeLayer.bounds[2].value - doc.activeLayer.bounds[0].value) / 2));
        desc3.putDouble(sTID("blurbWidgetLocationY"), doc.activeLayer.bounds[3].value);
        desc3.putBoolean(sTID("blurbWidgetSelected"), true);
        desc3.putBoolean(sTID("blurbWidgetEffectEnabled"), true);
        desc3.putDouble(sTID("blurbWidgetFade"), 100);
        desc3.putDouble(sTID("blurbTiltShiftInnerPoint1X"), doc.activeLayer.bounds[0].value + ((doc.activeLayer.bounds[2].value - doc.activeLayer.bounds[0].value) / 2));
        desc3.putDouble(sTID("blurbTiltShiftInnerPoint1Y"), doc.activeLayer.bounds[3].value);
        desc3.putDouble(sTID("blurbTiltShiftInnerPoint2X"), doc.activeLayer.bounds[0].value + ((doc.activeLayer.bounds[2].value - doc.activeLayer.bounds[0].value) / 2));
        desc3.putDouble(sTID("blurbTiltShiftInnerPoint2Y"), doc.activeLayer.bounds[3].value);
        desc3.putDouble(sTID("blurbTiltShiftOuterPoint1X"), doc.activeLayer.bounds[0].value + ((doc.activeLayer.bounds[2].value - doc.activeLayer.bounds[0].value) / 2));
        desc3.putDouble(sTID("blurbTiltShiftOuterPoint1Y"), doc.activeLayer.bounds[1].value);
        desc3.putDouble(sTID("blurbTiltShiftOuterPoint2X"), doc.activeLayer.bounds[0].value + ((doc.activeLayer.bounds[2].value - doc.activeLayer.bounds[0].value) / 2));
        desc3.putDouble(sTID("blurbTiltShiftOuterPoint2Y"), doc.activeLayer.bounds[3].value * 2);
        desc3.putDouble(sTID("blurbTiltShiftBlurAmount"), layerBlur);
        desc3.putDouble(sTID("blurbTiltShiftDistortion"), 0);
        desc3.putBoolean(sTID("blurbTiltShiftSymmetricDistortion"), false);
        desc3.putDouble(sTID("blurbTiltShiftCenterX"), doc.activeLayer.bounds[0].value + ((doc.activeLayer.bounds[2].value - doc.activeLayer.bounds[0].value) / 2));
        desc3.putDouble(sTID("blurbTiltShiftCenterY"), doc.activeLayer.bounds[3].value);
    } else if (layerAngle > 270 && layerAngle < 360) {
        desc3.putInteger(sTID("blurbWidgetType"), 3);
        desc3.putDouble(sTID("blurbWidgetLocationX"), doc.activeLayer.bounds[0].value + ((doc.activeLayer.bounds[2].value - doc.activeLayer.bounds[0].value) / 2));
        desc3.putDouble(sTID("blurbWidgetLocationY"), doc.activeLayer.bounds[3].value);
        desc3.putBoolean(sTID("blurbWidgetSelected"), true);
        desc3.putBoolean(sTID("blurbWidgetEffectEnabled"), true);
        desc3.putDouble(sTID("blurbWidgetFade"), 100);
        desc3.putDouble(sTID("blurbTiltShiftInnerPoint1X"), doc.activeLayer.bounds[0].value + ((doc.activeLayer.bounds[2].value - doc.activeLayer.bounds[0].value) / 2));
        desc3.putDouble(sTID("blurbTiltShiftInnerPoint1Y"), doc.activeLayer.bounds[3].value);
        desc3.putDouble(sTID("blurbTiltShiftInnerPoint2X"), doc.activeLayer.bounds[0].value + ((doc.activeLayer.bounds[2].value - doc.activeLayer.bounds[0].value) / 2));
        desc3.putDouble(sTID("blurbTiltShiftInnerPoint2Y"), doc.activeLayer.bounds[3].value);
        desc3.putDouble(sTID("blurbTiltShiftOuterPoint1X"), doc.activeLayer.bounds[0].value + ((doc.activeLayer.bounds[2].value - doc.activeLayer.bounds[0].value) / 2));
        desc3.putDouble(sTID("blurbTiltShiftOuterPoint1Y"), doc.activeLayer.bounds[1].value);
        desc3.putDouble(sTID("blurbTiltShiftOuterPoint2X"), doc.activeLayer.bounds[0].value + ((doc.activeLayer.bounds[2].value - doc.activeLayer.bounds[0].value) / 2));
        desc3.putDouble(sTID("blurbTiltShiftOuterPoint2Y"), doc.activeLayer.bounds[3].value * 2);
        desc3.putDouble(sTID("blurbTiltShiftBlurAmount"), layerBlur);
        desc3.putDouble(sTID("blurbTiltShiftDistortion"), 0);
        desc3.putBoolean(sTID("blurbTiltShiftSymmetricDistortion"), false);
        desc3.putDouble(sTID("blurbTiltShiftCenterX"), doc.activeLayer.bounds[0].value + ((doc.activeLayer.bounds[2].value - doc.activeLayer.bounds[0].value) / 2));
        desc3.putDouble(sTID("blurbTiltShiftCenterY"), doc.activeLayer.bounds[3].value);
    } else {
        if (layerAngle > 90 && layerAngle < 270) {
            desc3.putInteger(sTID("blurbWidgetType"), 3);
            desc3.putDouble(sTID("blurbWidgetLocationX"), doc.activeLayer.bounds[0].value + ((doc.activeLayer.bounds[2].value - doc.activeLayer.bounds[0].value) / 2));
            desc3.putDouble(sTID("blurbWidgetLocationY"), doc.activeLayer.bounds[1].value);
            desc3.putBoolean(sTID("blurbWidgetSelected"), true);
            desc3.putBoolean(sTID("blurbWidgetEffectEnabled"), true);
            desc3.putDouble(sTID("blurbWidgetFade"), 100);
            desc3.putDouble(sTID("blurbTiltShiftInnerPoint1X"), doc.activeLayer.bounds[0].value + ((doc.activeLayer.bounds[2].value - doc.activeLayer.bounds[0].value) / 2));
            desc3.putDouble(sTID("blurbTiltShiftInnerPoint1Y"), doc.activeLayer.bounds[1].value);
            desc3.putDouble(sTID("blurbTiltShiftInnerPoint2X"), doc.activeLayer.bounds[0].value + ((doc.activeLayer.bounds[2].value - doc.activeLayer.bounds[0].value) / 2));
            desc3.putDouble(sTID("blurbTiltShiftInnerPoint2Y"), doc.activeLayer.bounds[1].value);
            desc3.putDouble(sTID("blurbTiltShiftOuterPoint1X"), doc.activeLayer.bounds[0].value + ((doc.activeLayer.bounds[2].value - doc.activeLayer.bounds[0].value) / 2));
            desc3.putDouble(sTID("blurbTiltShiftOuterPoint1Y"), doc.activeLayer.bounds[1].value - (doc.activeLayer.bounds[3].value - doc.activeLayer.bounds[1].value));
            desc3.putDouble(sTID("blurbTiltShiftOuterPoint2X"), doc.activeLayer.bounds[0].value + ((doc.activeLayer.bounds[2].value - doc.activeLayer.bounds[0].value) / 2));
            desc3.putDouble(sTID("blurbTiltShiftOuterPoint2Y"), doc.activeLayer.bounds[3].value);
            desc3.putDouble(sTID("blurbTiltShiftBlurAmount"), layerBlur);
            desc3.putDouble(sTID("blurbTiltShiftDistortion"), 0);
            desc3.putBoolean(sTID("blurbTiltShiftSymmetricDistortion"), false);
            desc3.putDouble(sTID("blurbTiltShiftCenterX"), doc.activeLayer.bounds[0].value + ((doc.activeLayer.bounds[2].value - doc.activeLayer.bounds[0].value) / 2));
            desc3.putDouble(sTID("blurbTiltShiftCenterY"), doc.activeLayer.bounds[1].value);
        }
    }
    list1.putObject(sTID("blurbWidget"), desc3);
    desc1.putList(sTID("blurbWidgetList"), list1);
    executeAction(sTID("blurbTransform"), desc1, DialogModes.NO);
}

function zeroFill() {
    var desc1 = new ActionDescriptor();
    var ref1 = new ActionReference();
    ref1.putEnumerated(cTID("Lyr "), cTID("Ordn"), cTID("Trgt"));
    desc1.putReference(cTID("null"), ref1);
    var desc2 = new ActionDescriptor();
    desc2.putUnitDouble(sTID("fillOpacity"), cTID("#Prc"), 0);
    desc1.putObject(cTID("T   "), cTID("Lyr "), desc2);
    executeAction(cTID("setd"), desc1, DialogModes.NO);
}

function blendingMultiply() {
    var desc1 = new ActionDescriptor();
    var ref1 = new ActionReference();
    ref1.putEnumerated(cTID("Lyr "), cTID("Ordn"), cTID("Trgt"));
    desc1.putReference(cTID("null"), ref1);
    var desc2 = new ActionDescriptor();
    desc2.putEnumerated(cTID("Md  "), cTID("BlnM"), cTID("Mltp"));
    desc1.putObject(cTID("T   "), cTID("Lyr "), desc2);
    executeAction(cTID("setd"), desc1, DialogModes.NO);
}

function setShadowColor(layerColor) {
    var desc1 = new ActionDescriptor();
    var ref1 = new ActionReference();
    zeroFill();
    ref1.putProperty(cTID("Prpr"), cTID("Lefx"));
    ref1.putEnumerated(cTID("Lyr "), cTID("Ordn"), cTID("Trgt"));
    desc1.putReference(cTID("null"), ref1);
    var desc2 = new ActionDescriptor();
    desc2.putUnitDouble(cTID("Scl "), cTID("#Prc"), 100);
    var desc3 = new ActionDescriptor();
    desc3.putBoolean(cTID("enab"), true);
    desc3.putEnumerated(cTID("Md  "), cTID("BlnM"), cTID("Mltp"));
    desc3.putUnitDouble(cTID("Opct"), cTID("#Prc"), 100);
    var desc4 = new ActionDescriptor();
    desc4.putDouble(cTID("Rd  "), layerColor._r);
    desc4.putDouble(cTID("Grn "), layerColor._g);
    desc4.putDouble(cTID("Bl  "), layerColor._b);
    desc3.putObject(cTID("Clr "), sTID("RGBColor"), desc4);
    desc2.putObject(cTID("SoFi"), cTID("SoFi"), desc3);
    desc1.putObject(cTID("T   "), cTID("Lefx"), desc2);
    executeAction(cTID("setd"), desc1, DialogModes.NO);
    blendingMultiply();
}

function additionalShadowBlur(layerAngle) {
    if (layerAngle >= 80 && layerAngle < 90) {
        motionBlur(10);
    } else if (layerAngle > 90 && layerAngle <= 100) {
        motionBlur(10);
    } else if (layerAngle >= 260 && layerAngle < 270) {
        motionBlur(10);
    } else {
        if (layerAngle > 270 && layerAngle <= 280) {
            motionBlur(10);
        }
    }
}

function setSelectionActiveLayer() {
    var desc1 = new ActionDescriptor();
    var ref1 = new ActionReference();
    ref1.putProperty(cTID("Chnl"), sTID("selection"));
    desc1.putReference(cTID("null"), ref1);
    var ref2 = new ActionReference();
    ref2.putEnumerated(cTID("Chnl"), cTID("Chnl"), cTID("Trsp"));
    desc1.putReference(cTID("T   "), ref2);
    executeAction(cTID("setd"), desc1, DialogModes.NO);
}

function intersectSelection(intersectValue, layerAngle, isShadowLayer) {
    var desc1 = new ActionDescriptor();
    var ref1 = new ActionReference();
    var doc = app.activeDocument;
    intersectValue = Math.round((intersectValue / 100) * (doc.activeLayer.bounds[3].value - doc.activeLayer.bounds[1].value));
    ref1.putProperty(cTID("Chnl"), sTID("selection"));
    desc1.putReference(cTID("null"), ref1);
    var desc2 = new ActionDescriptor();
    if (isShadowLayer === true) {
        if (layerAngle > 90 && layerAngle <= 180) {
            desc2.putUnitDouble(cTID("Top "), cTID("#Pxl"), doc.activeLayer.bounds[1].value);
        } else if (layerAngle > 180 && layerAngle < 270) {
            desc2.putUnitDouble(cTID("Top "), cTID("#Pxl"), doc.activeLayer.bounds[1].value);
        } else if (layerAngle > 0 && layerAngle < 90) {
            desc2.putUnitDouble(cTID("Top "), cTID("#Pxl"), doc.activeLayer.bounds[3].value - intersectValue);
        } else {
            if (layerAngle > 270 && layerAngle < 360) {
                desc2.putUnitDouble(cTID("Top "), cTID("#Pxl"), doc.activeLayer.bounds[3].value - intersectValue);
            }
        }
    } else {
        desc2.putUnitDouble(cTID("Top "), cTID("#Pxl"), doc.activeLayer.bounds[3].value - intersectValue);
    }
    desc2.putUnitDouble(cTID("Left"), cTID("#Pxl"), 0);
    if (isShadowLayer === true) {
        if (layerAngle > 90 && layerAngle <= 180) {
            desc2.putUnitDouble(cTID("Btom"), cTID("#Pxl"), doc.activeLayer.bounds[1].value + intersectValue);
        } else if (layerAngle > 180 && layerAngle <= 270) {
            desc2.putUnitDouble(cTID("Btom"), cTID("#Pxl"), doc.activeLayer.bounds[1].value + intersectValue);
        } else if (layerAngle > 0 && layerAngle < 90) {
            desc2.putUnitDouble(cTID("Btom"), cTID("#Pxl"), doc.activeLayer.bounds[3].value);
        } else {
            if (layerAngle > 270 && layerAngle < 360) {
                desc2.putUnitDouble(cTID("Btom"), cTID("#Pxl"), doc.activeLayer.bounds[3].value);
            }
        }
    } else {
        desc2.putUnitDouble(cTID("Btom"), cTID("#Pxl"), doc.activeLayer.bounds[3].value);
    }
    desc2.putUnitDouble(cTID("Rght"), cTID("#Pxl"), doc.width.value);
    desc1.putObject(cTID("T   "), cTID("Rctn"), desc2);
    executeAction(sTID("interfaceWhite"), desc1, DialogModes.NO);
    selectionBounds = doc.selection.bounds;
    doc.selection.deselect();
    return selectionBounds;
}

function centerLayer() {
    var desc1 = new ActionDescriptor();
    var ref1 = new ActionReference();
    ref1.putEnumerated(cTID("Lyr "), cTID("Ordn"), cTID("Trgt"));
    desc1.putReference(cTID("null"), ref1);
    desc1.putEnumerated(cTID("Usng"), cTID("ADSt"), sTID("ADSCentersH"));
    executeAction(cTID("Algn"), desc1, DialogModes.NO);
}

function fixShadowPosition(originalLayer, layerAngle) {
    var doc = app.activeDocument;
    if (layerAngle == 90 || layerAngle == 270) {

    } else {
        shadowLayer = doc.activeLayer;
        setSelectionActiveLayer();
        shadowLayerBounds = intersectSelection(10, layerAngle, true);
        doc.activeLayer = originalLayer;
        setSelectionActiveLayer();
        originalLayerBounds = intersectSelection(10, layerAngle, false);
        doc.activeLayer = shadowLayer;
        if (layerAngle > 90 && layerAngle < 180) {
            doc.activeLayer.translate(UnitValue(-(shadowLayerBounds[0].value - originalLayerBounds[0].value), "px"), UnitValue(-((shadowLayerBounds[1].value - originalLayerBounds[3].value) + 1), "px"));
        } else if (layerAngle > 180 && layerAngle < 270) {
            doc.activeLayer.translate(UnitValue(-(shadowLayerBounds[2].value - originalLayerBounds[2].value), "px"), UnitValue(-((shadowLayerBounds[1].value - originalLayerBounds[3].value) + 1), "px"));
        } else if (layerAngle > 0 && layerAngle < 90) {
            doc.activeLayer.translate(UnitValue(-((shadowLayerBounds[0].value - originalLayerBounds[0].value) + 2), "px"), UnitValue((originalLayerBounds[3].value - shadowLayerBounds[3].value) + 1, "px"));
        } else if (layerAngle > 270 && layerAngle < 360) {
            doc.activeLayer.translate(UnitValue((originalLayerBounds[2].value - shadowLayerBounds[2].value) + 2, "px"), UnitValue((originalLayerBounds[3].value - shadowLayerBounds[3].value) + 1, "px"));
        } else {
            if (layerAngle == 180) {
                doc.activeLayer = originalLayer;
                setSelectionActiveLayer();
                doc.activeLayer = shadowLayer;
                centerLayer();
                doc.selection.deselect();
            }
        }
    }
}

function moveShadowLayer() {
    var desc1 = new ActionDescriptor();
    var ref1 = new ActionReference();
    ref1.putEnumerated(cTID("Lyr "), cTID("Ordn"), cTID("Trgt"));
    desc1.putReference(cTID("null"), ref1);
    var ref2 = new ActionReference();
    ref2.putEnumerated(cTID("Lyr "), cTID("Ordn"), cTID("Prvs"));
    desc1.putReference(cTID("T   "), ref2);
    executeAction(cTID("move"), desc1, DialogModes.NO);
}

function addShadowLayer(layerName, originalLayer) {
    var doc = app.activeDocument;
    shadowLayer = originalLayer.duplicate();
    doc.activeLayer = shadowLayer;
    if (hasLayerMask()) {
        applyLayerMask();
    } else {
        shadowLayer.rasterize(RasterizeType.ENTIRELAYER);
    }
    doc.activeLayer.name = layerName;
    moveShadowLayer();
}

function createShadow(layerAngle, layerScale, layerBlur, layerOpacity, layerColor, originalLayer) {
    addShadowLayer("Shadow", originalLayer);
    setShadowAngle(layerAngle, layerScale);
    setShadowColor(layerColor);
    setShadowBlur(layerAngle, layerBlur);
    app.activeDocument.activeLayer.opacity = layerOpacity;
    additionalShadowBlur(layerAngle);
    fixShadowPosition(originalLayer, layerAngle);
}

function deleteOldShadow() {
    var doc = app.activeDocument;
    var hasLayerLinks = [];
    hasLayerLinks = doc.activeLayer.linkedLayers;
    if (hasLayerLinks.length > 0) {
        for (var i = 0; i < hasLayerLinks.length; i += 1) {
            theLayer = hasLayerLinks[i];
            if (theLayer.name === "Shadow") {
                theLayer.remove();
                return;
            }
        }
    } else {
        return;
    }
}

function mainScript(shadowAngle, shadowScale, shadowBlur, shadowOpacity, shadowColor, sunPosition) {
    var doc = app.activeDocument;
    var sunValues = [];
    var layerAngle = shadowAngle;
    var layerScale = shadowScale;
    var layerBlur = shadowBlur;
    var layerOpacity = shadowOpacity;
    var layerColor = shadowColor;
    var sunPointXY = [];
    originalLayer = app.activeDocument.activeLayer;
    originalResolution = doc.resolution;
    originalRulerUnits = preferences.rulerUnits;
    if (originalLayer.name !== "Shadow") {
        preferences.rulerUnits = Units.PIXELS;
        if (originalResolution != 72) {
            doc.resizeImage(undefined, undefined, 72, ResampleMethod.NONE);
        }
        if (sunPosition === true) {
            sunValues = calcSunAngle();
            if (sunValues.length === 3) {
                layerAngle = sunValues[0];
                sunPointXY.push(sunValues[1], sunValues[2]);
                deleteOldShadow();
                createShadow(layerAngle, layerScale, layerBlur, layerOpacity, layerColor, originalLayer);
                doc.activeLayer.link(originalLayer);
                doc.activeLayer = originalLayer;
                returnSun(sunPointXY);
            }
        } else {
            doc.pathItems.removeAll();
            deleteOldShadow();
            createShadow(layerAngle, layerScale, layerBlur, layerOpacity, layerColor, originalLayer);
            doc.activeLayer.link(originalLayer);
            doc.activeLayer = originalLayer;
        }
        if (originalResolution != 72) {
            doc.resizeImage(undefined, undefined, originalResolution, ResampleMethod.NONE);
        }
        preferences.rulerUnits = originalRulerUnits;
    } else {
        alert("请不要选择该投影！", "BBTools Shadow", false);
    }
}

function main(shadowAngle, shadowScale, shadowBlur, shadowOpacity, shadowColor, sunPosition) {
    if (isOpen() && isRGB() && isNotEmpty() && onlyOneLayerSelected() && isValidLayer() && noBackgroundLayer()) {
        try {
            var myShadowAngle = shadowAngle;
            var myShadowScale = shadowScale;
            var myShadowBlur = shadowBlur;
            var myShadowOpacity = shadowOpacity;
            var mySunPosition = sunPosition;
            var myShadowColor = shadowColor;
            app.activeDocument.suspendHistory("BBTools Shadow", "mainScript(myShadowAngle, myShadowScale, myShadowBlur, myShadowOpacity, myShadowColor, mySunPosition)");
        } catch (e) {
            if (e.number != 8007) {
                showError(e);
            }
        }
    }
}